; Initialization routines
;
; guiInitialize
; guiInitializeV
; guiVersion
;
; All Data to be copied to ramcode is stored here.

guiInitialize:
 ld a,THIS_VERSION
 cp c
 ret c
 push bc
 ld hl,myRamCodeStart
 ld de,usableramcode
 ld bc,myRamCodeEnd-myRamCodeStart
 ldir
 in a,(6)
 ld (de),a
 pop bc
 or a       ;reset carry flag
 ret

guiVersion:
 ld a,THIS_VERSION
 ret

; All of data to put into ramcode comprises 36 bytes.
; The 37th holds the page that gui is on.

myRamCodeStart:

; Hey look! It's the gcall code!
gocode:															;Total: 36 bytes / 253 clocks
	ex (sp),hl													;1/19
	push de														;1/11
	ld de,mycall-myRamCodeStart+usableramcode+1		;3/10
	ldi															;2/16
	ldi															;2/16
	inc bc														;1/6
	inc bc														;1/6
	pop de														;1/10
	ex (sp),hl													;1/19
	push hl														;1/11
	push af														;1/11
	in a,(6)														;2/11
	ld l,a														;1/4
	ld a,(guiPage)												;3/13
	out (6),a													;2/11
	pop af														;1/10
	ex (sp),hl													;1/19
mycall:
	call 0000h													;3/10
	ex	(sp),hl													;1/19
	push af														;1/11
	ld	a,l														;1/4
	out (6),a													;2/11
	pop af														;1/10
	pop hl														;1/10
	ret															;1/10

myRamCodeEnd:
